#include <iostream>

using namespace std;

int main()
{

    int n;
    cin>>n;
    int a[100000];
    for(int i=1;i<=n;i++){
        cin>>a[i];
    }
    int u[100000],v[100000];
    for(int i=1;i<=n-1;i++){
        cin>>u[i]>>v[i];
    }
    cout<<a[1]<<endl;
    cout<<1<<endl<<1<<endl<<0<<endl;

    return 0;
}